<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class Fastrack_Wp_Settings_Option {

	static $setting_name = "fastrack_wp_option_opts";

	/**
	 * Fastrack_Wp_Settings_option constructor.
	 */
	public function __construct() {
		if ( is_admin() ) { // admin actions
            add_action( 'admin_menu', array( $this, 'add_menu' ) );
            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );
            wp_enqueue_script('artus-field-color-js','/Field_Color.js',array('jquery', 'farbtastic'),time(),true);	
            wp_enqueue_style( 'farbtastic' );
		}
	}

	function add_menu() {
        add_menu_page('FastrackWP', 'FastrackWP', 'manage_options', 'fastrack_wp', array( $this, 'social_settings_page' ));
		add_submenu_page( 'fastrack_wp', 'FastrackWP','Options', 'manage_options', 'fastrack_wp', array( $this, 'social_settings_page' ) );
        
	}

	function social_settings_page() {
        global $wpdb;
		if (isset($_POST['save'])) {
			$this->save_settings($_POST['settings_option']);
		}
        
		$options = self::get_settings();
		$text_domain = Fastrack_Wp_Main::$text_domain;
		Fastrack_Wp_Main::render( "settings_option", compact( 'options', 'text_domain' ) );
        
	}

	function save_settings( $settings ) {
		update_option( self::$setting_name, $settings);
	}

	public function enqueue_scripts() {
		wp_enqueue_style( 'wp-fastrack', Fastrack_Wp_Main::wp_get_css_script_file_path( 'admin.css' ) );
	}

	public static function get_settings() {
        $options = get_option( self::$setting_name, array() );
		if ( empty( $options['forms']['friend'] ) ) {
			ob_start();
			Fastrack_Wp_Main::render( "email/friend_default" );
			$options['forms']['friend'] = ob_get_clean();
			update_option( self::$setting_name, $options );
		}
		if ( empty( $options['forms']['enquire'] ) ) {
			ob_start();
			Fastrack_Wp_Main::render( "email/enquire_default" );
			$options['forms']['enquire'] = ob_get_clean();
			update_option( self::$setting_name, $options );
		}
		return $options;
	}
    public static function get_form_template($type) {
		$settings = self::get_settings();
		return isset($settings['forms'][$type]) ? $settings['forms'][$type] : '';
	}
}