<?php if ( !defined( 'ABSPATH' ) ) exit; /* Exit if accessed directly */ ?>

<h1><?php echo _e( 'Fastrack WP Import Settings', $text_domain ) ?></h1>
<hr>
<br>
<form name='general_setup' method='post' action=''>	
	<div id="my-left" style="float: left; width: 49%; max-width: 500px;">
		<input type="hidden" id="file_id" value="<?php echo $file_id ?>">
		<div class="my-block">
			<div class="wc-oe-header">
				<?php echo _e( 'XML-data folder', $text_domain ) ?>:
			</div>
			<label id="export_filename">
				<input type="text" name="options[xml_data_folder]" class="width-100" value="<?php echo isset( $options[ 'xml_data_folder' ] ) ? $options[ 'xml_data_folder' ] : ABSPATH . 'xml-data/' ?>" >
			</label>
		</div>
		<br>
	</div> 
</form>

<div id="my-right" style="float: left; width: 48%; margin: 0px 10px; max-width: 500px;">
	<!--	<form name='xml_upload' method='post' action=''>	
			<div class="my-block">
				<div class="wc-oe-header"><?php echo _e( 'Upload XML', $text_domain ) ?></div>
				<input type="file" name="fileToUpload" id="fileToUpload">
				<input type="submit" class="button button-secondary" value="Upload" name="submit">
			</div>
		</form>
		<br>-->
	<form name='xml_import'  enctype="multipart/form-data" method='post' action=''>	
		<div class="my-block">
			<div class="wc-oe-header"><?php echo _e( 'Import XML', $text_domain ) ?></div>
			<input type="file" name="fileToUpload" id="fileToUpload">
			<input type="submit" value="Import" class="button button-primary" name="submit">
		</div>
	</form>

</div>

<div style="clear: both;"></div>
<button class="button" id="run_now"><?php _e( 'Run Now', $text_domain ); ?></button>
<button class="button button-primary" id="save_opt"><?php _e( 'Save', $text_domain ); ?></button>
<button class="button" id="stop_now" style="display: none;" onclick="window.enabledImport = false; get_all(100); return false;"><?php _e( 'Abort Import', $text_domain ); ?></button>
<br><br>
<div id="progress_div" style="display: none;">
	<div id="progressBar"><div></div></div>
</div>

<h3><?php _e('Cron Job Scheduler Auto Import', $text_domain ) ?></h3>
<?php if(empty($optionz['cron_schedule'])){
  ?>
  <p>No CRON job has been detected. Please make sure you have set this up.</p>
<table class="form-table">
	<tbody>
	<?php
    if ( defined( 'DISABLE_WP_CRON' ) && DISABLE_WP_CRON ) {}else{?>
	<tr>
		<td><?php _e( "define('DISABLE_WP_CRON', true);", $text_domain ) ?></td>
		<td>
			<label>
				You need to disable the default WordPress cron job schedules and setup a unix cronjob.<br> Please add the following to the end of your<br> <span style="font-family: monospace"><?php echo esc_html(get_home_path()."wp-config.php"); ?></span> file.
			</label>
		</td>
	</tr>
	<?php } ?>
	<tr>
		<td><pre style="word-wrap: break-word">0 * * * * wget -qO- "<?php echo get_home_url(); ?>/wp-cron.php?doing_wp_cron" &>/dev/null</pre></td>
		<td>
			<label>
				Once this has been added. It is important that you also setup a cron job to run every 30 minute,<br> the recommended setting for your installation.
			</label>
		</td>
	</tr>
	</tbody>
</table>
    <?php  
}else{
    ?>
    <table class="widefat striped">
       <thead>
           <tr>
               <td>Hook Name</td>
               <td>Last Run</td>
               <td>Next Run</td>
           </tr>
       </thead>
        <tbody>
           <tr>
               <td>wp_fastrack_import_xml_cron</td>
               <td><?php echo(date("Y-m-d H:i:s",$optionz['cron_schedule']));?></td>
               <td><?php echo(date("Y-m-d H:i:s",$optionz['cron_schedule']+1800));?></td>
           </tr>
        </tbody>
    </table>
    <?php
}
?>

<script>
	var enabledImport = true;
	jQuery( document ).ready( function( $ ) {
		var data;
		if ( $( "#file_id" ).val() )
		{
			import_start(1);
		}
		

		$( "#save_opt" ).click( function( e ) {
			e.preventDefault;
			jQuery.ajax( {
				type: "POST",
				url: ajaxurl,
				dataType: "json",
				data: { action: 'fastrack_wp_xml', m: 'save_opt', data: jQuery( 'form[name=general_setup]' ).serialize( ) }
			} ).done( function( msg ) {
//				jQuery.notifyBar( {
//					cssClass: "success",
//					html: "Settings Updated"
//				} );
				location.reload( );
			} );
		} );


		$( "#run_now" ).click( function( e ) {
			import_start();
		} );
	} );


	function import_start(file) {
		file = typeof file !== 'undefined' ? file : 0;
		window.enabledImport = true;
		jQuery('#run_now').attr('disabled', 'disabled');
		jQuery('#stop_now').css('display', 'inline-block');
		var data = {
			action: 'fastrack_wp_xml',
			m: 'run_now',
			step: 'start',
			file:file,
		}
		jQuery.ajax( {
			type: "post",
			data: data,
			cache: false,
			url: ajaxurl,
			dataType: "json",
			error: function( xhr, status, error ) {
				alert( xhr.responseText );
			},
			success: function( response ) {
				window.count = response.left;
				console.log( window.count );
				if ( window.count > 0 )
					get_all( 0 );
				else
					alert( "Nothing to import" );
			}
		} );
	}

	function progress( percent, $element ) {

		if ( percent == 0 ) {
			$element.find( 'div' ).html( percent + "%&nbsp;" ).animate( { width: 0 }, 0 );
			jQuery( '#progress_div' ).show();
		}
		else {
			var progressBarWidth = percent * $element.width() / 100;
			$element.find( 'div' ).html( percent + "%&nbsp;" ).animate( { width: progressBarWidth }, 200 );

			if ( percent >= 100 ) {
				jQuery( '#progress_div' ).hide();
				jQuery('#run_now').removeAttr('disabled');
				jQuery('#stop_now').css('display', 'none');
			}
		}
	}

	function get_all( percent ) {
		if (!window.enabledImport) {
			progress( 100, jQuery( '#progressBar' ) );
			return;
		}
		progress( parseInt( percent, 10 ), jQuery( '#progressBar' ) );

		if ( percent < 100 ) {
			var data = {
				action: 'fastrack_wp_xml',
				m: 'run_now',
				step: 'next_step'
			}

			jQuery.ajax( {
				type: "post",
				data: data,
				cache: false,
				url: ajaxurl,
				dataType: "json",
				error: function( xhr, status, error ) {
					alert( xhr.responseText );
					progress( 100, jQuery( '#progressBar' ) );
				},
				success: function( response ) {
					get_all( (window.count - response.left)/window.count * 100 )
				}
			} );
		}
		else
			alert("Import Done");
	}


</script>

