<?php

if ( !defined( 'ABSPATH' ) ) {
	exit;
}
define( 'DFI_FEATURED_METAKEY', 'dfiFeatured' );

class Fastrack_Wp_Import {
    private static $newproduct=array();
    private static $oldproduct=array();
    private static $ddid;
	function __construct( $path ) {
		add_filter( 'upload_mimes', array( $this, 'add_extended_mime_types' ) );
		add_action( 'wp_ajax_import_mmacxml_file', array( $this, 'import_mmacxml_file' ) );
		add_action( 'wp_ajax_nopriv_import_mmacxml_file', array( $this, 'import_mmacxml_file' ) );
		$this->path = $path;
	}

	function add_extended_mime_types( $mime_types = array() ) {
		$mime_types[ 'xml' ] = 'application/xml';
		return $mime_types;
	}

	function import_mmacxml_file( $file_id, $start ) {
		global $wpdb, $mmac_xml_data, $total_items, $imported_items;
		$import_per_request = 5;

		$file_id		 = $file_id;
		$imported_items	 = $start;
		header( 'Content-Type: application/json' );

		$mmac_xml_data = array();

		$uploaddir		 = $this->path;
		$full_path		 = $uploaddir . $file_id . ".xml";
		
		$mmac_xml_data	 = $this->get_mmacxml_data( $full_path );
		$total_items	 = count( $mmac_xml_data );

		$ids = '0';
		for ( $x = 1; $x <= $import_per_request; $x++ ) {
			if ( $total_items > $imported_items ) {
				$item = $mmac_xml_data[ $imported_items ];

				$item_image_count = $this->import_mmac_xml_item( $item, $full_path );

				$imported_items++;

				$ajax_msg		 = 'Importing progress: ' . $imported_items . ' item';
				if ( $imported_items > 1 )
					$ajax_msg .= 's';
				$ajax_progress	 = 'importing';
			} else {
				echo json_encode( array( 'start' => $imported_items, "percent" => 100 ) );
				$content_image_files_count	 = $this->mmac_delete_xml_images_files( $full_path );
			    //unlink($full_path);
			    $this->mmac_delete_draft_products();
				return;
				break;
			}
		}

		$percent			 = $imported_items / $total_items;
		$ajax_progress_bar	 = number_format( $percent * 100 );


		//echo 'Imported products: '. count($mmac_xml_data);
		echo json_encode( array( 'start' => $imported_items, "percent" => $ajax_progress_bar ) );
		//}
		// debugging
		// echo '<pre>';
		// print_r($mmac_xml_data);
		// echo '</pre>';

		wp_die();
	}

	function mmacXML_to_Array( $xml ) {
		$xml_parser = xml_parser_create();
		xml_parse_into_struct( $xml_parser, $xml, $vals );
		xml_parser_free( $xml_parser );

		$_tmp = '';
		foreach ( $vals as $xml_elem ) {
			$x_tag	 = $xml_elem[ 'tag' ];
			$x_level = $xml_elem[ 'level' ];
			$x_type	 = $xml_elem[ 'type' ];
			if ( $x_level != 1 && $x_type == 'close' ) {
				if ( isset( $multi_key[ $x_tag ][ $x_level ] ) )
					$multi_key[ $x_tag ][ $x_level ] = 1;
				else
					$multi_key[ $x_tag ][ $x_level ] = 0;
			}
			if ( $x_level != 1 && $x_type == 'complete' ) {
				if ( $_tmp == $x_tag )
					$multi_key[ $x_tag ][ $x_level ] = 1;
				$_tmp							 = $x_tag;
			}
		}

		foreach ( $vals as $xml_elem ) {
			$x_tag				 = $xml_elem[ 'tag' ];
			$x_level			 = $xml_elem[ 'level' ];
			$x_type				 = $xml_elem[ 'type' ];
			if ( $x_type == 'open' )
				$level[ $x_level ]	 = $x_tag;
			$start_level		 = 1;
			$php_stmt			 = '$xml_array';
			if ( $x_type == 'close' && $x_level != 1 )
				$multi_key[ $x_tag ][ $x_level ] ++;
			while ( $start_level < $x_level ) {
				$php_stmt .= '[$level[' . $start_level . ']]';
				if ( isset( $multi_key[ $level[ $start_level ] ][ $start_level ] ) && $multi_key[ $level[ $start_level ] ][ $start_level ] )
					$php_stmt .= '[' . ($multi_key[ $level[ $start_level ] ][ $start_level ] - 1) . ']';
				$start_level++;
			}
			$add = '';
			if ( isset( $multi_key[ $x_tag ][ $x_level ] ) && $multi_key[ $x_tag ][ $x_level ] && ($x_type == 'open' || $x_type == 'complete') ) {
				if ( !isset( $multi_key2[ $x_tag ][ $x_level ] ) )
					$multi_key2[ $x_tag ][ $x_level ]	 = 0;
				else
					$multi_key2[ $x_tag ][ $x_level ] ++;
				$add								 = '[' . $multi_key2[ $x_tag ][ $x_level ] . ']';
			}
			if ( isset( $xml_elem[ 'value' ] ) && trim( $xml_elem[ 'value' ] ) != '' && !array_key_exists( 'attributes', $xml_elem ) ) {
				if ( $x_type == 'open' )
					$php_stmt_main	 = $php_stmt . '[$x_type]' . $add . '[\'content\'] = $xml_elem[\'value\'];';
				else
					$php_stmt_main	 = $php_stmt . '[$x_tag]' . $add . ' = $xml_elem[\'value\'];';
				eval( $php_stmt_main );
			}
			if ( array_key_exists( 'attributes', $xml_elem ) ) {
				if ( isset( $xml_elem[ 'value' ] ) ) {
					$php_stmt_main = $php_stmt . '[$x_tag]' . $add . '[\'content\'] = $xml_elem[\'value\'];';
					eval( $php_stmt_main );
				}
				foreach ( $xml_elem[ 'attributes' ] as $key => $value ) {
					$php_stmt_att = $php_stmt . '[$x_tag]' . $add . '[$key] = $value;';
					eval( $php_stmt_att );
				}
			}
		}
		return $xml_array;
	}

	function get_mmac_product_list( $dealer_id, $listing ) {
		$products	 = array();
		$list		 = array();
		$i			 = 0;
		if ( count( $listing ) > 0 ) {
			foreach ( $listing as $k => $item ) {
				$list[ 'DEALERID' ] = $dealer_id;

				if ( is_array( $item ) ) {
					foreach ( $item as $key => $v ) {
						if ( $key === 'ATTRIBUTES' ) {
							$att_array = array();
							foreach ( $v[ $i ][ 'ATTRIBUTE' ] as $att_k => $att_v ) {
								if ( $att_v[ 'NAME' ] == 'Retail Price' ) {
									if ( $att_v[ 'PRICE_TYPE' ] == 'POA' ) {
										$list[ 'Retail Price' ] = 0;
										$list[ 'Price' ] = 0;
									} else {
										$list[ 'Retail Price' ] = $att_v[ 'content' ];
										$list[ 'Price' ] = $att_v[ 'content' ];
									}
								} else {
                                    if(empty($att_v[ 'content' ])&&empty($list[ $att_v[ 'NAME' ] ])){
                                        $list[ $att_v[ 'NAME' ] ] = "N/A";
                                    }else{
								        $list[ $att_v[ 'NAME' ] ] = $att_v[ 'content' ];
                                    }
								}
							}
							//echo '<pre>';
							//print_r($att_array);
							//echo '</pre>';
						} else {
							$list[ $key ] = $v;
						}
					}
					$i++;
					$products[] = $list;
				} else {
					$list[ $k ] = $item;
				}
			}
		}

		return $products;
	}

	//add_shortcode('import_mmac_xml', 'import_mmacxml_shortcode');
	function get_mmacxml_data( $file_name ) {
		global $wpdb;
		//function import_mmacxml_shortcode($atts, $content = null) {
		//extract(shortcode_atts(array('file_name' => 'xml_file_name.xml', 'target'=>'listing', 'nested'=>'attributes'), $atts));
		//$file_name = 'https://www.mymachinery.com.au/3510.xml';
		$data		 = '';
		$i			 = 0;
//		error_log(print_r($file_name,1),3, 'log.log');
		$xml_file	 = fopen( $file_name, "rb" );
		if (!$xml_file) {
			return ;
		}
		while ( !feof( $xml_file ) ) {
			$data .= fread( $xml_file, 2048 );
		}
		fclose( $xml_file );

		$xml_array = $this->mmacXML_to_Array( $data );

		/* DEALER DATA
		  [ID] => 3510
		  [NAME] => Hutcheon & Pearce - Albury
		  [REMOTE_CUSTOMER_ID] => 259
		  [PHONE] => 02 6058 6800
		  [EMAIL] => AlburyAdmin@hutcheonandpearce.com.au
		  [ADDRESS_LINE_1] => Lot 222 Travelstop Way
		  [CITY] => Albury North
		  [STATE] => New South Wales
		  [POSTAL_CODE] => 2641
		  [COUNTRY] => Australia
		 */

		// Check the dealer
		$dealer_post = array(
			'post_title'	 => htmlspecialchars_decode( $xml_array[ 'DEALER' ][ 'NAME' ] ),
			'post_content'	 => '',
			'post_status'	 => 'publish',
			'post_type'		 => 'dealer',
			'post_author'	 => get_current_user_id(),
		//'post_category' => array(8,39)
		);
		// Insert/Update the dealer custom post into the database
		$sql		 = "SELECT post_id FROM `" . $wpdb->prefix . "postmeta` WHERE meta_key='dealer-data-xmlid' AND meta_value = '" . $xml_array[ 'DEALER' ][ 'ID' ] . "'";
        self::$ddid=$xml_array[ 'DEALER' ][ 'ID' ];
		$meta		 = $wpdb->get_results( $sql );
		if ( is_array( $meta ) && !empty( $meta ) && isset( $meta[ 0 ] ) ) {
			$meta = $meta[ 0 ];
		}
		if ( is_object( $meta ) ) {
			$xmlid = $meta->post_id;
		} else {
			$xmlid = '';
		}

		if ( $xmlid != '' ) {
			$dealer_post[ 'ID' ] = $xmlid;
			unset( $dealer_post[ 'post_type' ] );
			$dealer_id			 = @wp_update_post( $dealer_post, $wp_error );
		} else {
			$dealer_id = @wp_insert_post( $dealer_post, $wp_error );
		}
        
        self::$ddid=$dealer_id;
		// log
		echo ($xmlid ? 'UPDATED' : 'ADDED') . ": $dealer_id -> DEALER: " . $dealer_post['post_title'] . PHP_EOL . '<br>';

		// Save meta data
		$dealer_meta_boxes = array(
			"dealer-data-xmlid"		 => "ID",
			"dealer-data-phone"		 => "PHONE",
			"dealer-data-email"		 => "EMAIL",
			"dealer-data-address"	 => "ADDRESS_LINE_1",
			"dealer-data-city"		 => "CITY",
			"dealer-data-state"		 => "STATE",
			"dealer-data-postalcode" => "POSTAL_CODE",
			"dealer-data-country"	 => "COUNTRY"
		);
		foreach ( $dealer_meta_boxes as $meta_name => $xml_key ) {
			$make = get_post_meta( $dealer_id, $meta_name, true );
			@$this->save_meta_data( $dealer_id, $xml_array[ 'DEALER' ][ $xml_key ], $make, $meta_name );
		}

		// get product list
		$listing = $xml_array[ 'DEALER' ][ 'LISTING' ];
		return $this->get_mmac_product_list( $dealer_id, $listing );
	}

	// function that save the meta to database if new data is exists and is not equals to old one
	function save_meta_data( $post_id, $new_data, $old_data, $name ) {

		if ( $new_data == $old_data ) {

			add_post_meta( $post_id, $name, $new_data, true );
		} else if ( !$new_data ) {

			delete_post_meta( $post_id, $name, $old_data );
		} else if ( $new_data != $old_data ) {

			update_post_meta( $post_id, $name, $new_data, $old_data );
		}
	}

	function upload_item_image_file( $filename ) {
		$filename	 = $filename . '.jpg';
		$uploaddir	 = wp_upload_dir();

		$uploadfile	 = $uploaddir[ 'path' ] . '/' . $filename;
		$img_path	 = $this->path . $filename;

		if ( file_exists( $img_path ) ) {
			$savefile	 = fopen( $uploadfile, 'w' );
			$contents	 = file_get_contents( $img_path );
			fwrite( $savefile, $contents );
			fclose( $savefile );

			// Delete the original file
			//unlink($img_path);
			// inserting the image into the media library
			$wp_filetype = wp_check_filetype( basename( $filename ), null );

			$attachment = array(
				'post_mime_type' => $wp_filetype[ 'type' ],
				'post_title'	 => $filename,
				'post_content'	 => '',
				'post_status'	 => 'inherit'
			);

			$attach_id = wp_insert_attachment( $attachment, $uploadfile );

			$imagenew		 = get_post( $attach_id );
			$fullsizepath	 = get_attached_file( $imagenew->ID );
			require_once ( ABSPATH . 'wp-admin/includes/image.php' );
			$attach_data	 = wp_generate_attachment_metadata( $attach_id, $fullsizepath );
			wp_update_attachment_metadata( $attach_id, $attach_data );

			return $attach_id;
		}
		return 0;
	}

	function import_mmac_xml_item( $item, $full_path ) {
		global $wpdb;
		$meta_boxes		 = array(
			"product-data-xmlid"		 => "ID",
			"product-data-make"			 => "MAKE",
			"product-data-model"		 => "MODEL_SPECIFIC",
			"product-data-location"		 => "Location",
			"product-data-condition"	 => "Item Condition",
			"product-data-year"			 => "Year",
			"product-odometer"			 => "Odometer",
			"product-truck-config"		 => "Truck Config",
			"product-susp-options"		 => "Susp Options",
			"product-cab-option"		 => "Cab Option",
			"product-tare"		         => "Tare",
			"product-gvm"		         => "GVM",
			"product-gcm"		         => "GCM",
			"product-eng-type"		     => "Eng Type",
			"product-eng-power"		     => "Eng Power",
			"product-eng-size"		     => "Eng Size",
			"product-engine-make"		 => "Engine Make",
			"product-fuel-capacity"		 => "Fuel Capacity",
			"product-transmission"		 => "Transmission",
			"product-differential"		 => "Differential",
			"product-turntable-coupling" => "Turntable/ Coupling",
			"product-audio-visual-system"=> "Audio/Visual System",
			"product-comms-radio"		 => "Comms/Radio",
			"product-front-tyre-size"	 => "Front Tyre Size",
			"product-front-tyre-type"	 => "Front Tyre Type",
			"product-front-tyre-cond"	 => "Front Tyre Cond",
			"product-rear-tyre-size"	 => "Rear Tyre Size",
			"product-rear-tyre-type"	 => "Rear Tyre Type",
			"product-bullbar"		     => "Bullbar",
			"product-external-colour"	 => "External Colour",
			"_regular_price"		     => "Retail Price",
			"_price"		             => "Price",
			"_sku"		                 => "Stock/Ref #",
			"product-data-adtype"		 => "Ad Type",
			"product-data-listing"		 => "Listing Type",
			"product-option-dealerid"	 => "DEALERID"
		);
		//Check categories - [TYPE] AND [SUBTYPE]
		$parent_term_id	 = term_exists( $item[ 'TYPE' ], 'product_cat' );
		if ( $parent_term_id == 0 || $parent_term_id == null ) {
			$parent_term_id	 = wp_insert_term( $item[ 'TYPE' ], 'product_cat' );
			//var_dump($parent_term_id);die();
			$parent_term_id	 = $parent_term_id[ 'term_id' ];
		} else {
			$parent_term_id = $parent_term_id[ 'term_id' ];
		}

		$term_child = term_exists( $item[ 'SUBTYPE' ], 'product_cat' );
		if ( $term_child == 0 || $term_child == null ) {
			$args		 = array( 'parent' => $parent_term_id );
			$term_child	 = wp_insert_term( $item[ 'SUBTYPE' ], 'product_cat', $args );
			$term_child	 = $term_child[ 'term_id' ];
		} else {
			$term_child = $term_child[ 'term_id' ];
		}
		$post_terms = array( $parent_term_id, $term_child );

		@$permalink = $item[ 'MAKE' ] . '-' . $item[ 'MODEL_SPECIFIC' ] . '-' . $item[ 'Year' ] . '-' . $item[ 'Stock/Ref #' ];

		$product_post = array(
			//'ID'            => $item['ID'],
			'post_title'	 => $item[ 'MAKE' ] . ' ' . $item[ 'MODEL_SPECIFIC' ],
			//'post_name' => sanitize_title_with_dashes($permalink,'','save'),
			'post_content'	 => $item[ 'Description' ],
			'post_status'	 => 'publish',
			'post_type'		 => 'product',
			'post_author'	 => get_current_user_id()
		);
        
        if (in_array($item[ 'ID' ], self::$oldproduct)) {
            self::$newproduct[]=$item[ 'ID' ];
        }
        
		// Insert/Update the product custom post into the database
		$sql	 = "SELECT post_id FROM `" . $wpdb->prefix . "postmeta` WHERE meta_key='product-data-xmlid' AND meta_value = '" . $item[ 'ID' ] . "'";
		$meta	 = $wpdb->get_results( $sql );
		if ( is_array( $meta ) && !empty( $meta ) && isset( $meta[ 0 ] ) ) {
			$meta = $meta[ 0 ];
		}
		if ( is_object( $meta ) ) {
			$xmlid = $meta->post_id;
		} else {
			$xmlid = '';
		}

		if ( $xmlid != '' ) {
			$product_post[ 'ID' ]	 = $xmlid;
			unset( $product_post[ 'post_type' ] );
			$post_id				 = @wp_update_post( $product_post, $wp_error );
		} else {
			$post_id = @wp_insert_post( $product_post, $wp_error );
		}

		// log
		echo ($xmlid ? 'UPDATED' : 'ADDED') . ": $post_id -> PRODUCT: " . $product_post['post_title'] . PHP_EOL . '<br>';

		// attach images to post
		$basename				 = basename( $full_path, ".xml" );
		$filename				 = $basename . '_' . $item[ 'ID' ] . '_';
		$uploaded_image_count	 = 0;
		$featured_img_path		 = $this->path . $filename . '1.jpg';
    
		if ( file_exists( $featured_img_path ) ) {
			// delete post images
			$this->mmac_delete_product_images( $post_id );

			// Featured image
			$featured_image_id = $this->upload_item_image_file( $filename . '1', $post_id );
			if ( $featured_image_id ) {
				set_post_thumbnail( $post_id, $featured_image_id );
				$uploaded_image_count++;
			}

			// attachments
			$uploading		 = true;
			$post_images_url = "";
			$x				 = 2;
			while ( $uploading ) {
				$uploaded_image_id = $this->upload_item_image_file( $filename . $x, $post_id );
                
				if ( $uploaded_image_id ) {
					$post_images_url.=$uploaded_image_id.',';
                    $uploaded_image_count++;
				} else {
					$uploading = false;
				}
				$x++;
                
			}
            rtrim($post_images_url,",");

			update_post_meta( $post_id, '_product_image_gallery', $post_images_url );

			//update_post_meta($post_id, DFI_FEATURED_METAKEY, $uploaded_image_id);
		}
		//Set product categories
		wp_set_post_terms( $post_id, $post_terms, 'product_cat' );

		// Save meta data
		foreach ( $meta_boxes as $meta_name => $xml_key ) {
			$make = get_post_meta( $post_id, $meta_name, true );
			@$this->save_meta_data( $post_id, $item[ $xml_key ], $make, $meta_name );
		}

		return $uploaded_image_count;
	}

	function mmac_xml_import_start() {
		$xml_files = glob( $this->path . '*xml' );
		if ( is_array( $xml_files ) ) {
			file_put_contents( PLUGIN_Fastrack_Wp_TEMP_PATH . 'import', serialize( $xml_files ) );
//			$xml_files = unserialize( file_get_contents( PLUGIN_Fastrack_Wp_ROOT_PATH . 'import' ) ); // debug

			return count( $xml_files );
		}
		return 0;
	}

	function mmac_xml_import_next_step() {
		global $wpdb;
		$time_start				 = microtime( true );
		date_default_timezone_set( 'Australia/Brisbane' );
		$date					 = date( 'j/m/Y h:i:s a', time() );
		$logs					 = '* * * * * * * * [' . $date . '] IMPORTING BEGIN * * * * * * * *' . PHP_EOL;
		$xml_items_images_count	 = array();
		$total_images_count		 = 0;
		$processed_image_count	 = 0;
         
		$files = unserialize( file_get_contents( PLUGIN_Fastrack_Wp_TEMP_PATH . 'import' ) );
		$logs					 .= print_r($files,true).'* * * * * * * * [' . $date . '] IMPORTING * * * * * * * *' . PHP_EOL;
		$filename = '';
		if ( is_array( $files ) ) {
			$filename = current( $files );
		}

		if ($filename) {
           
			$key = key( $files );
			//bogos_write_to_file($filename);
			$xml_items_images_count	 = array();
			$xml_file_item_count	 = 0;
			$xml_file_image_count	 = 0;

			$mmac_xml_data	 = $this->get_mmacxml_data( $filename );
			$basename		 = basename( $filename, ".xml" );

			// Set the products status of the current Dealer to "draf"
			$sql	 = "SELECT post_id FROM `" . $wpdb->prefix . "postmeta` WHERE meta_key='dealer-data-xmlid' AND meta_value = '" . $basename . "'";
			$meta	 = $wpdb->get_results( $sql );
			if ( is_array( $meta ) && !empty( $meta ) && isset( $meta[ 0 ] ) ) {
				$meta = $meta[ 0 ];
			}
			if ( is_object( $meta ) ) {
				$sql	 = "SELECT post_id FROM `" . $wpdb->prefix . "postmeta` WHERE meta_key='product-option-dealerid' AND meta_value = '" . $meta->post_id . "'";
				$postids = $wpdb->get_col( $sql );
				if ( $postids ) {
					foreach ( $postids as $id ) {
						$post = array( 'ID' => $id, 'post_status' => 'draft' );
						wp_update_post( $post );
					}
				}
			}
            //product old and new remove
            $oldsqls	 = "SELECT t1.meta_value FROM `" . $wpdb->prefix . "postmeta` as t1 JOIN `" . $wpdb->prefix . "postmeta` as t2 ON t1.post_id=t2.post_id WHERE (t2.meta_key='product-option-dealerid' AND t2.meta_value = '" . self::$ddid . "') AND (t1.meta_key='product-data-xmlid')";
            $oldsqls	 = $wpdb->get_results( $oldsqls );
            foreach($oldsqls as $oldsql=>$oldval){
                self::$oldproduct[]=$oldval->meta_value;
            }
            //end
			// All image files of the current XML file
			$current_xml_image_files = glob( $this->path . $basename . '_*' );

			foreach ( $mmac_xml_data as $item ) {
				$item_image_files		 = glob( $this->path . $basename . '_' . $item[ 'ID' ] . '_*' );
				$current_xml_image_files = array_diff( $current_xml_image_files, $item_image_files );
				$item_image_count		 = $this->import_mmac_xml_item( $item, $filename );
				$xml_file_image_count	 = $xml_file_image_count + $item_image_count;
				$xml_file_item_count++;
			}

			// Delete the images which not associated to the XML file
			if ( count( $current_xml_image_files ) > 0 ) {
				foreach ( $current_xml_image_files as $file_name ) {
					unlink( $file_name );
				}
			}
            
            $temparr=array_diff(self::$oldproduct,self::$newproduct);
            if(!empty($temparr)&&!empty(self::$oldproduct)&&!empty(self::$newproduct)){
                foreach($temparr as $oldpro){
                    $oldsqls	 = "SELECT post_id FROM `" . $wpdb->prefix . "postmeta` WHERE meta_key='product-data-xmlid' AND meta_value ='".$oldpro."'";
                    $oldsqls	 = $wpdb->get_results( $oldsqls );
                    $wpdb->delete( $wpdb->prefix.'postmeta', array( 'post_id' => $oldsqls[0]->post_id ) );
                    $wpdb->delete( $wpdb->prefix.'posts', array( 'id' => $oldsqls[0]->post_id ) );
                }
            }
			$xml_items_images_count[ 'items' ]	 = $xml_file_item_count;
			$xml_items_images_count[ 'images' ]	 = $xml_file_image_count;

			$processed_image_count = $processed_image_count + $xml_items_images_count[ 'images' ];

			$logs .= 'XML file: ' . $basename . '.xml, imported item count: ' . $xml_items_images_count[ 'items' ] . ', imported image count: ' . $xml_items_images_count[ 'images' ] . PHP_EOL;

			$basename			 = basename( $filename, ".xml" );
			$image_files		 = glob( $this->path . $basename . '_*' );
			$total_images_count	 = $total_images_count + count( $image_files );

			$logs .= '------------------------------------------------------------------------' . PHP_EOL;
			$logs .= 'Total image count: ' . $total_images_count . ', Processed image count: ' . $processed_image_count . PHP_EOL;

			$time_end	 = microtime( true );
			$time		 = $time_end - $time_start;
			$logs .= '* * * * * * * [Importing duration: ' . gmdate( "H:i:s", $time ) . '] IMPORTING END * * * * * * *' . PHP_EOL . PHP_EOL;
			// Save to log file
			$savefile	 = ABSPATH . 'xml-data/importing.log';
			file_put_contents( $savefile, $logs, FILE_APPEND );

			if ( $total_images_count != $processed_image_count ) {
				do_action( 'mmac_xml_import_cron_hook' );
			} else {
				$file_names				 = '';
				$total_image_files_count = 0;
					// Backup XML file
				$basename	 = basename( $filename, ".xml" );
				$file_date	 = date( 'Y-m-d-h-i-s-a', time() );
				$newfile	 = ABSPATH . 'backup-xml/' . $basename . '-xml-' . $file_date . '.log';
				copy( $filename, $newfile );
				$content = '----------------' . $basename . '-xml-' . $file_date . '.log ----------------' . PHP_EOL;

				$content_image_files_count	 = $this->mmac_delete_xml_images_files( $filename );
				/*
				  // Delete XML file
				  unlink($filename);

				  // Delete image files
				  $image_files = glob(ABSPATH .'xml-data/'. $basename .'_*');
				  $image_files_count = 0;
				  foreach($image_files as $file_name) {
				  unlink($file_name);
				  $content .= $file_name . PHP_EOL;
				  $image_files_count++;
				  }
				 */
				$content .= $content_image_files_count[ 0 ];
				$image_files_count			 = $content_image_files_count[ 1 ];
				$content .= '* * * * * * * * Image count: ' . $image_files_count . ' * * * * * * * *' . PHP_EOL . PHP_EOL;
				$total_image_files_count	 = $total_image_files_count + $image_files_count;

				$content .= '* * * * * * * * Total image count: ' . $total_image_files_count . ' * * * * * * * *' . PHP_EOL . PHP_EOL;
				$content .= '* * * * * * * * * * * * * * * * * * * * * * * * *' . PHP_EOL . PHP_EOL;

				$this->mmac_delete_draft_products();

				$this->bogos_write_to_file( $content, 'backup-xml/image_names.log' );
			}

			unset( $files[ $key ] );
			file_put_contents( PLUGIN_Fastrack_Wp_TEMP_PATH . 'import', serialize( $files ) );
		}

		return count( $files );
	}

	//MMAC XML import cron 
	function mmac_xml_import_cron() {
		$left = $this->mmac_xml_import_start();
		while ($left) {
			$left = $this->mmac_xml_import_next_step();
		}
		file_put_contents( PLUGIN_Fastrack_Wp_TEMP_PATH . 'import', '' );
		echo 'Import completed';
	}

	function mmac_delete_xml_images_files( $filename ) {
		$basename = basename( $filename, ".xml" );
		// Delete XML file
		unlink( $filename );

		// Delete image files
		$image_files		 = glob( $this->path . $basename . '_*' );
		$content			 = '';
		$image_files_count	 = 0;
		foreach ( $image_files as $file_name ) {
			unlink( $file_name );
			$content .= $file_name . PHP_EOL;
			$image_files_count++;
		}

		return array( $content, $image_files_count );
	}

	function mmac_delete_product_images( $post_id ) {
		global $wpdb;
		$attachment_id = get_post_thumbnail_id( $post_id );
		if ( $attachment_id != '' ) {
			wp_delete_attachment( $attachment_id, true );

			$featured_img = get_post_meta( $post_id, DFI_FEATURED_METAKEY, true );
			if ( !empty( $featured_img ) && count( $featured_img ) > 0 ) {
				$upload_dir	 = wp_upload_dir();
				$baseurl	 = $upload_dir[ 'baseurl' ];
				foreach ( $featured_img as $img ) {
					$image_names = explode( ',', $img );
					$filename	 = substr( strrchr( $image_names[ 1 ], "/" ), 1 );
					$image_name	 = str_replace( ".jpg", "-jpg", $filename );

					//$attachment = $wpdb->get_col("SELECT ID FROM " . $wpdb->prefix . "posts WHERE post_name='". $image_name ."';" );
					$attachment	 = $wpdb->get_col( "SELECT ID FROM " . $wpdb->prefix . "posts WHERE post_name='" . $image_name . "';" );
					$id			 = $attachment[ 0 ];

					wp_delete_attachment( $id, true );
				}
				delete_post_meta( $post_id, DFI_FEATURED_METAKEY );
			}
		}
	}

	function mmac_delete_draft_products() {
		global $wpdb;
		$sql	 = "SELECT ID FROM `" . $wpdb->prefix . "posts` WHERE post_type='product' AND post_status = 'draft'";
		$postids = $wpdb->get_col( $sql );
		if ( $postids ) {
			foreach ( $postids as $id ) {
				$this->mmac_delete_product_images( $id );
				wp_delete_post( $id, true );
			}
		}
	}

	function bogos_write_to_file( $content, $file = 'xml-data/Bo_debugging.txt' ) {
		$savefile = ABSPATH . $file;
		file_put_contents( $savefile, $content, FILE_APPEND );
	}

	// DEBUGGING FUNCTION
	// do_shortcode('[debugging_mmacxml_data]');
	function debugging_mmacxml_data_shortcode() {
		$file_name	 = ABSPATH . 'backup-xml/0282-xml-12-02-2016-07-00-08-pm.log';
		$data		 = '';
		$xml_file	 = fopen( $file_name, "rb" );
		if ( $xml_file ) {
			while ( !feof( $xml_file ) ) {
				$data .= fread( $xml_file, 2048 );
			}
			fclose( $xml_file );

			$xml_array = mmacXML_to_Array( $data );
			// echo '<pre style="clear: both;">';
			// print_r($xml_array);
			// echo '</pre>';

			$listing = $xml_array[ 'DEALER' ][ 'LISTING' ];
			echo '<pre style="clear: both;">';
			print_r( $this->get_mmac_product_list( 0, $listing ) );
			echo '</pre>';
		}
	}

}