<?php

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

class Fastrack_Wp_Main {

	public static $text_domain = "fastrack_wp";

	function __construct() {
		add_action( 'init', array( $this, 'init' ) );
		add_action( 'wp_enqueue_scripts', array( $this, 'wp_enqueue_scripts' ) );

		add_action( 'init', array( $this, 'products_plugin_rules' ) );
		//add plugin query vars (product_id) to wordpress
		add_filter( 'query_vars', array( $this, 'products_plugin_query_vars' ) );

		add_shortcode( 'fastrack_wp_big_search', array( $this, 'big_search' ) );
		add_shortcode( 'fastrack_wp_small_search', array( $this, 'small_search' ) );
		add_shortcode( 'fastrack_wp_search_content', array( $this, 'search_content' ) );
		add_shortcode( 'fastrack_wp_recent_products', array( $this, 'recent_products' ) );
		add_shortcode( 'fastrack_wp_quick_links', array( $this, 'quick_links' ) );

		add_action( 'wp_ajax_fastrack_wp', array( $this, 'ajax' ) );
		add_action( 'wp_ajax_nopriv_fastrack_wp', array( $this, 'ajax' ) );

        add_filter( 'woocommerce_product_tabs', array( $this, 'wp_fastrack_woo_remove_reviews_tab' ), 98 );
        add_filter( 'get_product_search_form' , array( $this, 'small_search' ) );
        
        add_filter( 'plugin_action_links_' . PLUGIN_Fastrack_Wp_ROOT_NAME, array( $this, 'plugin_action_links' ) );

        add_filter( 'plugin_row_meta', array( $this, 'fastrack_wp_plugin_row_meta' ), 10, 4 );

        add_filter('woocommerce_get_price_html', array( $this, 'wp_fastrack_woo_change_free_price' ), 10, 2);
        
        add_filter( 'woocommerce_is_sold_individually', array( $this, 'wp_fastrack_woo_remove_all_quantity_fields' ), 10, 2 );
        
        add_action( 'get_header', array( $this, 'wp_fastrack_woo_remove_storefront_sidebar' ) );
        
        add_filter( 'woocommerce_single_product_summary', array( $this, 'wp_fastrack_woo_template_single_social_sharing' ), 50 );
        add_action( 'woocommerce_before_single_product_summary', array( $this, 'wp_fastrack_woo_image_content_wrapper_start' ), 20 );
        add_action( 'woocommerce_after_single_product_summary', array( $this, 'wp_fastrack_woo_image_content_wrapper_end' ), 17 );
        
        add_action( 'woocommerce_after_single_product_summary', array( $this, 'wp_fastrack_woo_product_enqury_form' ), 18 );
        add_filter( 'woocommerce_single_product_summary', array( $this, 'wp_fastrack_woo_prodcut_details' ), 20 );
        
        add_action( 'wp_enqueue_scripts', array( $this, 'fastrack_wp_add_inline_css' ) );
        add_action( 'woocommerce_before_single_product_summary', 'wp_fastrack_woo_summary_wrap_start',40 );
        function cron_add_minute( $schedules ) {
            // Adds once every minute to the existing schedules.
            $schedules['everythirtyminute'] = array(
                'interval' => 1800,
                'display' => __( 'Once Every Thirty Minute' )
            );
            return $schedules;
        }
        add_filter( 'cron_schedules', 'cron_add_minute' );
        function wp_fastrack_woo_summary_wrap_start(){
            echo "<div class=col-sm-5>";
        }
        add_action( 'woocommerce_after_single_product_summary', 'wp_fastrack_woo_summary_wrap_end',1 );
        function wp_fastrack_woo_summary_wrap_end(){
            echo "</div>";
        }
		new Fastrack_Wp_Settings_Option();
		new Fastrack_Wp_Support();
	}
	function init() {

		Fastrack_Wp_Post_Type_Dealer::register();
		Fastrack_Wp_Post_Type_Product::register();
	}
    
	function wp_enqueue_scripts() {
		if ( is_single() ) {

			wp_enqueue_script( 'bxslider', $this->wp_get_js_script_file_path( 'jquery.bxslider.min.js' ), array( 'jquery' ) );
			wp_enqueue_script( 'fancybox', $this->wp_get_js_script_file_path( 'jquery.fancybox-1.3.4.js' ), array( 'jquery' ) );
			wp_enqueue_script( 'rrssb', $this->wp_get_js_script_file_path( 'rrssb.min.js' ), array( 'jquery' ) );
			wp_enqueue_script( 'single-product', $this->wp_get_js_script_file_path( 'single-product.js' ), array( 'jquery' ) );
			wp_enqueue_script( 'jquery-flexslider-js', $this->wp_get_js_script_file_path( 'jquery.flexslider.js' ), array( 'jquery' ) );

			wp_enqueue_style( 'bxslider', $this->wp_get_css_script_file_path( 'jquery.bxslider.css' ) );
			wp_enqueue_style( 'fancybox', $this->wp_get_css_script_file_path( 'jquery.fancybox-1.3.4.css' ) );
			wp_enqueue_style( 'rrssb', $this->wp_get_css_script_file_path( 'rrssb.css' ) );
			wp_enqueue_style( 'flexslider-css', $this->wp_get_css_script_file_path( 'flexslider.css' ) );
			wp_enqueue_style( 'fdnfeed-product-carousel', $this->wp_get_css_script_file_path( 'fdnfeed-product-carousel.css' ) );

			wp_enqueue_script( 'thickbox', null, array( 'jquery' ), true );
			wp_enqueue_style( 'thickbox.css', includes_url( '/js/thickbox/thickbox.css' ), null, '1.0' );
			wp_localize_script( 'single-product', 'fastrack_ajax_object', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
		} else {
			wp_enqueue_style( 'fastrack-wp-css', $this->wp_get_css_script_file_path( 'style.css' ) );
		}
			wp_enqueue_style( 'wp-fastrack-style', $this->wp_get_css_script_file_path( 'wp-fastrack-style.css' ) );
	}
    
    function plugin_action_links($links) {
        $action_links = array(
                'settings' => '<a href="' . admin_url( 'admin.php?page=fastrack_wp' ) . '">Settings</a>',
            );

        return array_merge( $action_links, $links );
    }
    
    function fastrack_wp_plugin_row_meta( $plugin_meta, $plugin_file) {
        if(defined('PLUGIN_Fastrack_Wp_ROOT_NAME')&&(PLUGIN_Fastrack_Wp_ROOT_NAME==$plugin_file)){
            $plugin_meta[] = '<a href="http://fastrackwp.com/support/" target="_blank">Docs</a>';
            $plugin_meta[] = '<a href="http://fastrackwp.com/support/" target="_blank">Support</a>';
	   }
        return $plugin_meta;
    }
    
    function fastrack_wp_add_inline_css() {
        $settings_colors = Fastrack_Wp_Settings_Option::get_settings();
        $wp_fastrack_style_custom_css = "
            .fdnfeed-product-form p button{
                background-color: ".(isset( $settings_colors['color']['btn_color'] ) ? $settings_colors['color']['btn_color'] : "#e24446" ).";
            }
            .fdnfeed-product-form p button:hover,
            .fdnfeed-product-form p button:focus,
            .fdnfeed-product-form p button:active {
                background-color: ".(isset( $settings_colors['color']['btn_hover_color'] ) ? $settings_colors['color']['btn_hover_color'] : "#a52c2e" )." !important;
                color: #fff;
            }

            .fdnfeed-product-form p input:focus,
            .fdnfeed-product-form p textarea:focus {
                outline: none !important;
                border-color: ".(isset( $settings_colors['color']['btn_color'] ) ? $settings_colors['color']['btn_color'] : "#e24446" )." !important;
            }
            .fdnfeed-product-form {
                background-color: ".(isset( $settings_colors['color']['enq_form_bg_color'] ) ? $settings_colors['color']['enq_form_bg_color'] : "#f6f6f6" ).";
            }
            .single-product .fdnfeed-product-form h4 {
                border-bottom: 1px solid ".(isset( $settings_colors['color']['btn_color'] ) ? $settings_colors['color']['btn_color'] : "#e24446" ).";
            }
            .fdnfeed-product-dealer-meta {
                background-color: ".(isset( $settings_colors['color']['dealer_bg_color'] ) ? $settings_colors['color']['dealer_bg_color'] : "#f6f6f6" ).";
            }
            ";
      wp_add_inline_style( 'wp-fastrack-style', $wp_fastrack_style_custom_css );
    }
    function wp_fastrack_woo_image_content_wrapper_end(){
            ?>
        </div>
            <?php
    }
    function wp_fastrack_woo_image_content_wrapper_start(){
        $options = Fastrack_Wp_Settings_Option::get_settings();
        if($options['layout']==1){
            echo '<div class="col-md-12">';
        }else{
            echo '<div class="col-md-8">';
        }
    }
    function wp_fastrack_woo_product_enqury_form(){
        $text_domain = Fastrack_Wp_Main::$text_domain;
        $dealerid	 = get_post_field( 'product-option-dealerid', $post->ID );
        $options = Fastrack_Wp_Settings_Option::get_settings();
        include_once 'class-fastrack-wp-rrssb.php';
        ob_start();
        Fastrack_Wp_Main::render( "single_product_enqury_form", compact( 'post', 'options', 'text_domain', 'dealerid' ) );
        $contentz	 = ob_get_clean();
        echo $contentz;
    }
    function wp_fastrack_woo_prodcut_details(){
        $text_domain = Fastrack_Wp_Main::$text_domain;
        $dealerid	 = get_post_field( 'product-option-dealerid', $post->ID );
        include_once 'class-fastrack-wp-rrssb.php';
        ob_start();
        Fastrack_Wp_Main::render( "single_product_details", compact( 'post', 'text_domain', 'dealerid' ) );
        $contentz	 = ob_get_clean();
        echo $contentz;
    }
    function wp_fastrack_woo_template_single_social_sharing() { 
        
                Fastrack_Wp_RRSSB::rrssb();
               
    }

    function wp_fastrack_woo_remove_all_quantity_fields( $return, $product ) {
        $options = get_option( Fastrack_Wp_Settings_Option::$setting_name, array() );
        if(!empty($options['catalog_mode'])){
            remove_action( 'woocommerce_single_product_summary', 'woocommerce_template_single_add_to_cart', 30 );
            remove_action( 'woocommerce_after_shop_loop_item', 'woocommerce_template_loop_add_to_cart', 10 );
        }
        remove_action( 'woocommerce_sidebar', 'woocommerce_get_sidebar', 10 );
        return true;
    }
    function wp_fastrack_woo_change_free_price($price, $product) {
        error_log($price);
        if ( $price == wc_price( 0.00 ) )
            return 'POA';
        else
            return $price;
    }
    function wp_fastrack_woo_remove_reviews_tab($tabs) {
                unset($tabs['reviews']);
                return $tabs;
    }
    function wp_fastrack_woo_remove_storefront_sidebar() {
        if ( is_product() ) {
            remove_action( 'storefront_sidebar', 'storefront_get_sidebar', 10 );
        }
    }

	private static function wp_get_script_file_path( $name, $type = 'js' ) {
		$template = locate_template( "fastrack_wp/$type/$name", false, true );

// Allow themes to override script
		if ( $template ) {
			return $template;
		} else {
			return PLUGIN_Fastrack_Wp_ROOT_URL . "assets/$type/$name";
		}
	}

	public static function wp_get_js_script_file_path( $name ) {
		return self::wp_get_script_file_path( $name, 'js' );
	}

	public static function wp_get_css_script_file_path( $name ) {
		return self::wp_get_script_file_path( $name, 'css' );
	}

	function ajax() {
		if ( !empty( $_REQUEST[ 'method' ] ) ) {
			$method = 'ajax_' . $_REQUEST[ 'method' ];
			if ( method_exists( $this, $method ) ) {
				$this->$method();
			}
		}
		die();
	}

	function ajax_import() {
		$obj = new Fastrack_Wp_Settings();
		$obj->import_xml_sch();
	}

	function ajax_send_enquire_email() {
		$options = Fastrack_Wp_Settings_Option::get_settings();
		if ( !empty( $_POST[ 'email' ] ) && !empty( $_POST[ 'post_id' ] ) ) {
			$post_id	 = $_POST[ 'post_id' ];
			$template	 = Fastrack_Wp_Settings_Option::get_form_template( 'enquire' );

			$replacement = array(
				'{Date}'			 => current_time( 'mysql' ),
				'{Product Name}'	 => get_post_field( 'post_title', $post_id ),
				'{Product Stock}'	 => get_post_meta( $post_id, '_sku', true ),
				'{Product Url}'		 => trailingslashit( get_permalink( $post_id ) ),
				'{Name}'			 => isset( $_POST[ 'name' ] ) ? $_POST[ 'name' ] : '',
				'{Email}'			 => isset( $_POST[ 'email' ] ) ? $_POST[ 'email' ] : '',
				'{Phone}'			 => isset( $_POST[ 'phone' ] ) ? $_POST[ 'phone' ] : '',
				'{Message}'			 => isset( $_POST[ 'message' ] ) ? $_POST[ 'message' ] : '',
			);

			$template	 = str_ireplace( array_keys( $replacement ), array_values( $replacement ), $template );
			$subject	 = __( 'MyMachinery Enquire: ', self::$text_domain ) . get_post_field( 'post_title', $post_id ) . ' ' . get_post_meta( 'product-data-stockno', $post_id, true );
			$to			 = get_post_meta( get_post_meta( $post_id, 'product-option-dealerid', 1 ), 'dealer-data-email', 1 );
            if(!empty($options['default_dealer'])){
                if(!empty($options['default_email'])){
                    $to=$options['default_email'];
                }else{
                    $to=get_option('admin_email');
                }
            }elseif(empty($to)){
                if(!empty($options['default_email'])){
                    $to=$options['default_email'];
                }else{
                    $to=get_option('admin_email');
                }
            }
			$headers = array();
			$headers[] = 'content-type: text/html';

			if ( !empty( $to ) ) {
				$ret = wp_mail( $to, $subject, $template, $headers );
			} else {
				$ret = false;
			}
		} else {
			$ret = false;
		}

		if ( $ret ) {
			$msg = __( 'Your message has been sent', self::$text_domain );
		} else {
			$msg = __( 'Your message has not been sent'.$engs, self::$text_domain );
		}

		echo json_encode( array( 'success' => $ret, 'msg' => $msg ) );
	}

	function ajax_send_friend_email() {
		if ( !empty( $_POST[ 'friend_email' ] ) && !empty( $_POST[ 'post_id' ] ) ) {
			$post_id	 = $_POST[ 'post_id' ];
			$template	 = Fastrack_Wp_Settings_Option::get_form_template( 'friend' );

			$replacement = array(
				'{Message}'				 => isset( $_POST[ 'email_body' ] ) ? $_POST[ 'email_body' ] : '',
				'{Product Name}'		 => get_post_field( 'post_title', $post_id ),
				'{Product Description}'	 => get_post_field( 'post_content', $post_id ),
				'{Product Stock}'		 => get_post_meta( $post_id, '_sku', true ),
				'{Product Url}'			 => trailingslashit( get_permalink( $post_id ) ),
				'{Domain Url}'			 => get_bloginfo( 'url' ),
				'{Domain Name}'			 => get_bloginfo( 'name' ),
				'{Friend Name}'			 => $_POST[ 'friend_name' ],
				'{Friend Email}'		 => $_POST[ 'friend_email' ],
				'{User Name}'			 => $_POST[ 'your_name' ],
				'{User Email}'			 => $_POST[ 'your_email' ],
			);

			$template	 = str_ireplace( array_keys( $replacement ), array_values( $replacement ), $template );
			$headers = array();
			$headers[] = 'content-type: text/html';

			$subject	 = get_post_field( 'post_title', $post_id ) . ' ' . get_post_meta( 'product-data-stockno', $post_id, true );

			$ret = wp_mail( $_POST[ 'friend_email' ], $subject, $template, $headers );
		} else {
			$ret = false;
		}

		if ( $ret ) {
			$msg = __( 'Your message has been sent', self::$text_domain );
		} else {
			$msg = __( 'Your message has not been sent', self::$text_domain );
		}

		echo json_encode( array( 'success' => $ret, 'msg' => $msg ) );
	}

	function recent_products( $atts ) {
        
		$options = Fastrack_Wp_Settings::get_settings();
		$limit	 = 4;
		$return  = "";
		if ( isset( $atts[ 'max' ] ) )
			$limit	 = $atts[ 'max' ];

		$args = array( 'post_type' => 'product', 'posts_per_page' => $limit );

		if ( isset( $atts[ 'category' ] ) && ($atts[ 'category' ]) )
			$args[ 'tax_query' ] = array(
				array(
					'taxonomy'	 => 'product_cat',
					'field'		 => 'term_id',
					'terms'		 => $atts[ 'category' ]
				)
			);

		$loop = new WP_Query( $args );
		//$slug	 = $atts[ 'slug' ];
		//$return .="<div class='fdnfeed-wrapper'>";
		//$return .="<div style='list-style-type: none;' class='list-space'>";
		while ( $loop->have_posts() ) : $loop->the_post();
            global $product;
            $product_price = $product->get_price_html(); 
			$img = Fastrack_Wp_Post_Type_Product::get_mmac_product_image( get_the_ID() );

			// print_r($loop);
			// echo'</pre>';

			$return .= "<div class='fdnfeed-recent-product col-xs-3'><a href=" . get_permalink() . "><img src=" . $img . " class='fdnfeed-recent-product-img' style='width:242px;height:155px;'><h6>" . get_the_title() . "</a></h6><p>" .$product_price. " inc GST</p></div>";
		endwhile;
		$return .= '<div class="fdnfeed-recent-product col-xs-3"><a href=' . get_permalink( $options[ 'search_page_id' ] ) . '/?category=' . (isset( $atts[ 'category' ] ) ? $atts[ 'category' ] : "") . '&subcategory=&make=&price_min=&price_max=&keywords=&search=full_search&ppp=10&sb=adtype><img src="' . PLUGIN_Fastrack_Wp_ROOT_URL . '/assets/img/view.png" class="fdnfeed-recent-product-img" style="display:inline;"></a></div>';
		//$return .="</ul>";
		//$return .="</div>";
		return $return;
	}

	function get_quick_links() {
		$ret	 = array( __( 'All categories', self::$text_domain ) => '' );
		$terms	 = get_terms( 'product_cat', array(
			'orderby'	 => 'count',
			'order'		 => 'DESC',
			'number'	 => '7',
		) );

		/** @var WP_Term $term */
		foreach ( $terms as $term ) {
			$ret[ $term->name ] = $term->slug;
		}

		return $ret;
	}

	function big_search() {
		$options = Fastrack_Wp_Settings::get_settings();
		$links	 = $this->get_quick_links();
		self::render( "big_search", array( "options" => $options, "links" => $links ) );
	}

	function quick_links() {
		$options = Fastrack_Wp_Settings::get_settings();
		$links	 = $this->get_quick_links();
		self::render( "quick_links", array( "options" => $options, "links" => $links ) );
	}

	function small_search() {
		$options = Fastrack_Wp_Settings::get_settings();
		self::render( "small_search", array( "options" => $options ) );
	}

	function search_content() {
		$options = Fastrack_Wp_Settings::get_settings();

		$keywords	 = !empty($_GET[ 'keywords' ]) ? $_GET[ 'keywords' ] : '';
		$ppp		 = !empty($_GET[ 'ppp' ]) ? $_GET[ 'ppp' ] : 10;
		$sb 		 = !empty($_GET[ 'sb' ]) ? $_GET[ 'sb' ] : 'adtype';
		$filter		 = $sb;
        
		$num		 = (($sb=='adtype')?"meta_value":"meta_value_num");
		$asc		 = (($sb=='price_desc')?"DESC":"ASC");
		
        $sb          = (($sb=='adtype')?"product-data-adtype":"_regular_price");
        
		$paged		 = self::get_custom_search_current_page();
		$search_args = array(
			'post_type'		 => 'product',
			'posts_per_page' => $ppp,
			'meta_key'		 => $sb,
            'orderby'        => 'meta_value',
			'order'			 => $asc,
			'paged'			 => $paged,
			's'				 => $keywords,
			'meta_query'	 => array(
			// array(
			// 'key'     => 'product-data-make',
			// 'value'   => $make,
			// 'compare' => 'LIKE',
			// ),
			)
		);

		//var_dump( $search_args );

		$listing_type = array();
		if ( !empty($_GET[ 'listing_new' ]) )
			array_push( $listing_type, $_GET[ 'listing_new' ] );
		if ( !empty($_GET[ 'listing_demo' ]) )
			array_push( $listing_type, $_GET[ 'listing_demo' ] );
		if ( !empty($_GET[ 'listing_used' ]) )
			array_push( $listing_type, $_GET[ 'listing_used' ] );

		if ( !empty( $listing_type ) ) {
			$search_args[ 'meta_query' ][] = array(
				'key'		 => 'product-data-listing',
				'value'		 => $listing_type,
				'compare'	 => 'IN',
			);
		}

		$category = '';
		if (!empty($_GET[ 'category' ])) {
			$category = $_GET[ 'category' ];
		}
		else {
			$category_slug = self::get_custom_search_current_category();
			if ( $category_slug ) {
				$category = get_term_by('slug', $category_slug, 'product_cat')->term_id;
			}
		}

		if ( !empty($_GET[ 'subcategory' ]) ) {
			$category = array( $_GET[ 'subcategory' ] );
		}

		if ($category) {
			$search_args[ 'tax_query' ]	 = array(
					array(
							'taxonomy'	 => 'product_cat',
							'field'		 => 'term_id',
							'terms'		 => $category
					)
			);
		}

		if ( !empty($_GET[ 'make' ]) ) {
			$search_args[ 'meta_query' ][] = array(
				'key'		 => 'product-data-make',
				'value'		 => $_GET[ 'make' ],
				'compare'	 => '=',
			);
		}
		if ( !empty($_GET[ 'price_min' ]) ) {
			$search_args[ 'meta_query' ][] = array(
				'key'		 => '_regular_price',
				'value'		 => $_GET[ 'price_min' ],
				'type'		 => 'NUMERIC',
				'compare'	 => '>=',
			);
		}
		if ( !empty($_GET[ 'price_max' ]) ) {
			$search_args[ 'meta_query' ][] = array(
				'key'		 => '_regular_price',
				'value'		 => $_GET[ 'price_max' ],
				'type'		 => 'NUMERIC',
				'compare'	 => '<=',
			);
		}
		//print_r($listing);
		$productSearchQuery	 = new WP_Query( $search_args );
		// Pagination fix
		global $wp_query;
		$temp_query			 = $wp_query;
		$wp_query			 = NULL;
		$wp_query			 = $productSearchQuery;

		$total_pages = $wp_query->max_num_pages;
		$arr		 = get_defined_vars();
		//var_dump($arr);
		//die();
		self::render( "search_content", $arr );
	}

	static public function get_custom_search_current_category() {
		$current_page		 = $_SERVER[ 'REQUEST_URI' ];

		if ( !preg_match( "#" . sanitize_title(Fastrack_Wp_Settings::$search_page) . "\/([^\/?]+)/#", $current_page, $matches ) )
			return '';
		$category = $matches[ 1 ];
		if (strpos($category, 'page-') !== false) {
			return '';
		}

		return $category;
	}

	static public function get_custom_search_current_page() {
		$current_page		 = $_SERVER[ 'REQUEST_URI' ];
		$sub_page			 = '/page-';
		$using_pagination	 = strpos( $current_page, $sub_page );

		if ( $using_pagination === false ) {
			return 1;
		} else {
			if ( !preg_match( "#page-(\d+)#", $current_page, $matches ) )
				return 1;
			$page_number = $matches[ 1 ];

			if ( is_numeric( $page_number ) ) {
				return $page_number;
			}
		}
	}

	function products_plugin_rules() {
		add_rewrite_rule( sanitize_title(Fastrack_Wp_Settings::$search_page).'/([^/].+)/page-(\d+)', 'index.php?pagename='.sanitize_title(Fastrack_Wp_Settings::$search_page).'&fastrack_page_id=$matches[2]&category=$matches[1]', 'top' );
		add_rewrite_rule( sanitize_title(Fastrack_Wp_Settings::$search_page).'/page-(\d+)', 'index.php?pagename='.sanitize_title(Fastrack_Wp_Settings::$search_page).'&fastrack_page_id=$matches[1]', 'top' );
		add_rewrite_rule( sanitize_title(Fastrack_Wp_Settings::$search_page).'/([^/]+)', 'index.php?pagename='.sanitize_title(Fastrack_Wp_Settings::$search_page).'&fastrack_page_id=1&category=$matches[1]', 'top' );
	}

	function products_plugin_query_vars( $vars ) {
		$vars[] = 'fastrack_page_id';
		$vars[] = 'category';
		return $vars;
	}


	function the_content( $content ) {
		global $post;

		if ( $post->post_type === Fastrack_Wp_Post_Type_Product::POST_TYPE ) {
			$text_domain = self::$text_domain;
			$dealerid	 = get_post_field( 'product-option-dealerid', $post->ID );
			include_once 'class-fastrack-wp-rrssb.php';
			ob_start();
			self::render( "single_product", compact( 'post', 'text_domain', 'dealerid' ) );
			$content	 = ob_get_clean();
		}
		return $content;
	}

	function the_title( $post_title, $post_id ) {
		global $post;
		if ( is_single() && $post->ID === $post_id && $post->post_type === Fastrack_Wp_Post_Type_Product::POST_TYPE ) {
			$post_title = '';
		}
		return $post_title;
	}

	public static function render( $template_name, $data = array() ) {
		$template = locate_template( "fastrack_wp/$template_name.php", false, true );

		extract( $data );
// Allow themes to override template
		if ( $template ) {
			include( $template );
		} else {
			include( PLUGIN_Fastrack_Wp_ROOT_PATH . "templates/$template_name.php" );
		}
	}

}
