<?php

if ( !defined( 'ABSPATH' ) ) {
	exit;
}

class Fastrack_Wp_Support {
	function __construct() {
		if ( is_admin() ) { // admin actions
			add_action( 'admin_menu', array( $this, 'add_menu' ) );
			add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );
		}
	}

	function add_menu() {
		add_submenu_page( 'fastrack_wp', 'Support', 'Support', 'manage_options', 'wp_fastrack_support', array( $this, 'page' ) );
	}

	function page() {
		$text_domain = Fastrack_Wp_Main::$text_domain;
		Fastrack_Wp_Main::render( 'support', compact( 'text_domain' ) );
	}

	public function enqueue_scripts() {
		wp_enqueue_style( 'wp-fastrack', Fastrack_Wp_Main::wp_get_css_script_file_path( 'admin.css' ) );
	}
}

